//+------------------------------------------------------------------+ 
//|    $DYN                                                          | 
//|                                                                  | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFT AND DONATIONS ACCEPTED                                    | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| Use www.efxgroup.com as your forex broker...                     |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 

#property copyright "Avery T. Horton, Jr. aka TheRumpledOne  2008" 

#property link      "www.kreslik.com" 
#property indicator_chart_window 
#property indicator_buffers 1 


//---- buffers 

double _Value[];

double DynR[]; 
double DynS[]; 
 

//---- fixed input parameters 

 int      max_bars=1000; 
 bool      bResetOnNewDay = true; 
 int       iPeriods=5; 

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
//---- indicators 
   SetIndexStyle(0,DRAW_ARROW); 
   SetIndexArrow(0,119); 
   SetIndexBuffer(0, _Value ); 
   SetIndexEmptyValue(0,0.0); 


//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- 
    
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
    if(counted_bars < 0) 
        return(-1); 
//---- 


   int limit=Bars-counted_bars; 
    
   DynR[0] = Close[0]; 
   DynS[0] = Close[0]; 

   double nHH, nLL; 
   double range; 
 
   
   int processBars=MathMin(limit, max_bars); 
   for(int i=processBars;i>=0;i--){ 
      if ((Period() < PERIOD_D1) && //if timeframe below day 
         (TimeDay(Time[i])!=TimeDay(Time[i+1])) && // new day 
         (bResetOnNewDay)) { // reset if different day 
         DynR[i] = iHigh(NULL,0,i); 
         DynS[i] = iLow(NULL,0,i); 
      } //end if 
      else 
      { 
         nHH = High[Highest(NULL,0,MODE_HIGH,iPeriods,i)]; 
         nLL = Low[Lowest(NULL,0,MODE_LOW,iPeriods,i)]; 

         DynR[i] =   nHH; 
         DynS[i] =   nLL; 

         if ((DynR[i] != iHigh(NULL,0,i) ) && (DynR[i] < DynR[i+1]) &&  ( DynR[i+1] != 0 ))     
            DynR[i] = DynR[i+1]; 

         if (( DynS[i] != iLow(NULL,0,i) ) && (DynS[i] > DynS[i+1] ) && ( DynS[i+1] != 0 )) 
            DynS[i] = DynS[i+1]; 
            
      } 

          
  //          range  = DynR[i] - DynS[i] ; 

              range  = nHH - nLL ;           
            
            
// double xRet = iClose(NULL,0,i) - DynS[i] ;

double xRet = iClose(NULL,0,i) - nLL ;

if ( range != 0 ) { _Value[i] =  ( 100 * xRet ) / ( range ); }

// _Value[i] = DynR[i] ;
  
   } //end for 

    
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 

